import traceback

from cpl_core.console import Console

from bot_api.abc.dto_abc import DtoABC


class VersionDTO(DtoABC):
    def __init__(self, major: str = None, minor: str = None, micro: str = None):
        DtoABC.__init__(self)

        self._major = major
        self._minor = minor
        self._micro = micro

    @property
    def major(self) -> str:
        return self._major

    @property
    def minor(self) -> str:
        return self._minor

    @property
    def micro(self) -> str:
        return self._micro

    @property
    def str(self) -> str:
        return f"{self._major}.{self._minor}.{self._micro}"

    def from_dict(self, values: dict):
        self._major = values["major"]
        self._minor = values["minor"]
        self._micro = values["micro"]

    def to_dict(self) -> dict:
        return {
            "major": self._major,
            "minor": self._minor,
            "micro": self._micro,
        }
