from datetime import datetime
from typing import Optional

from cpl_core.database import TableABC

from bot_data.model.user import User


class ApiKey(TableABC):
    def __init__(
        self,
        identifier: str,
        key: str,
        creator: Optional[User],
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._id = id
        self._identifier = identifier
        self._key = key
        self._creator = creator

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def identifier(self) -> str:
        return self._identifier

    @property
    def key(self) -> str:
        return self._key

    @property
    def creator(self) -> Optional[User]:
        return self._creator

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
            SELECT * FROM `ApiKeys`;
        """
        )

    @staticmethod
    def get_select_string(identifier: str, key: str) -> str:
        return str(
            f"""
            SELECT * FROM `ApiKeys`
            WHERE `Identifier` = '{identifier}'
            AND `Key` = '{key}';
        """
        )

    @staticmethod
    def get_select_by_key(key: str) -> str:
        return str(
            f"""
            SELECT * FROM `ApiKeys`
            WHERE `Key` = '{key}';
        """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
            INSERT INTO `ApiKeys` (
                `Identifier`, `Key`, `CreatorId`, `CreatedAt`, `LastModifiedAt`
            ) VALUES (
                '{self._identifier}',
                '{self._key}',
                {"NULL" if self._creator is None else self._creator.user_id},
                '{self._created_at}',
                '{self._modified_at}'
            );
        """
        )

    @property
    def udpate_string(self) -> str:
        return str(
            f"""
            UPDATE `ApiKeys`
            SET `Identifier` = '{self._identifier}',
            `Key` = '{self._key}',
            `LastModifiedAt` = '{self._modified_at}'
            WHERE `Id` = {self._id};
        """
        )

    @property
    def delete_string(self) -> str:
        return str(
            f"""
            DELETE FROM `ApiKeys`
            WHERE `Id` = {self._id};
        """
        )
