from ariadne import MutationType

from bot_graphql.mutations.auto_role_mutation import AutoRoleMutation
from bot_graphql.mutations.auto_role_rule_mutation import AutoRoleRuleMutation
from bot_graphql.mutations.level_mutation import LevelMutation
from bot_graphql.mutations.user_mutation import UserMutation


class Mutation(MutationType):
    def __init__(
        self,
        auto_role_mutation: AutoRoleMutation,
        auto_role_rule_mutation: AutoRoleRuleMutation,
        level_mutation: LevelMutation,
        user_mutation: UserMutation,
    ):
        MutationType.__init__(self)

        self._auto_role_mutation = auto_role_mutation
        self._auto_role_rule_mutation = auto_role_rule_mutation
        self._level_mutation = level_mutation
        self._user_mutation = user_mutation

        self.set_field("autoRole", self.resolve_auto_role)
        self.set_field("autoRoleRule", self.resolve_auto_role_rule)
        self.set_field("level", self.resolve_level)
        self.set_field("user", self.resolve_user)

    def resolve_auto_role(self, *_):
        return self._auto_role_mutation

    def resolve_auto_role_rule(self, *_):
        return self._auto_role_rule_mutation

    def resolve_level(self, *_):
        return self._level_mutation

    def resolve_user(self, *_):
        return self._user_mutation
