from bot_data.model.known_user import KnownUser
from bot_graphql.abc.data_query_abc import DataQueryABC


class KnownUserQuery(DataQueryABC):
    def __init__(self):
        DataQueryABC.__init__(self, "KnownUser")

        self.set_field("id", self.resolve_id)
        self.set_field("discordId", self.resolve_discord_id)

    @staticmethod
    def resolve_id(x: KnownUser, *_):
        return x.known_user_id

    @staticmethod
    def resolve_discord_id(x: KnownUser, *_):
        return x.discord_id
