from cpl_discord.service import DiscordBotServiceABC

from bot_data.model.user_joined_voice_channel import UserJoinedVoiceChannel
from bot_graphql.abc.data_query_abc import DataQueryABC


class UserJoinedVoiceChannelQuery(DataQueryABC):
    def __init__(self, bot: DiscordBotServiceABC):
        DataQueryABC.__init__(self, "UserJoinedVoiceChannel")

        self._bot = bot

        self.set_field("id", self.resolve_id)
        self.set_field("channelId", self.resolve_channel_id)
        self.set_field("channelName", self.resolve_channel_name)
        self.set_field("user", self.resolve_user)
        self.set_field("joinedOn", self.resolve_joined_on)
        self.set_field("leavedOn", self.resolve_leaved_on)

    @staticmethod
    def resolve_id(x: UserJoinedVoiceChannel, *_):
        return x.join_id

    @staticmethod
    def resolve_channel_id(x: UserJoinedVoiceChannel, *_):
        return x.dc_channel_id

    def resolve_channel_name(self, x: UserJoinedVoiceChannel, *_):
        return self._bot.get_channel(x.dc_channel_id).name

    @staticmethod
    def resolve_user(x: UserJoinedVoiceChannel, *_):
        return x.user

    @staticmethod
    def resolve_joined_on(x: UserJoinedVoiceChannel, *_):
        return x.joined_on

    @staticmethod
    def resolve_leaved_on(x: UserJoinedVoiceChannel, *_):
        return x.leaved_on
