import discord
from cpl_discord.events import OnMessageABC

from bot_core.helper.event_checks import EventChecks
from bot_core.logging.message_logger import MessageLogger
from modules.level.service.level_service import LevelService


class LevelOnMessageEvent(OnMessageABC):
    def __init__(self, logger: MessageLogger, level: LevelService):
        OnMessageABC.__init__(self)
        self._logger = logger
        self._level = level

    @EventChecks.check_is_ready()
    async def on_message(self, message: discord.Message):
        self._logger.debug(__name__, f"Module {type(self)} started")
        await self._level.check_level(message.author)
