import { HttpClient } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { SettingsService } from "../settings/settings.service";
import { map, Observable } from "rxjs";
import { Variables } from "../../models/graphql/variables.model";

@Injectable({
  providedIn: "root"
})
export class DataService {

  constructor(
    private appsettings: SettingsService,
    private http: HttpClient
  ) {
  }

  // query(query: string, variables: object = {}): Observable<QueryResult> {
  //   return this.http.post<QueryResult>(`${this.appsettings.getApiURL()}/api/graphql`,
  //     JSON.stringify({
  //       query, variables
  //     }), {
  //       headers: new HttpHeaders({
  //         "Content-Type": "application/json"
  //       })
  //     }
  //   );
  // }

  public query<T>(query: string, variables?: Variables, f?: Function): Observable<T> {
    return this.http
      .post<{ data: T }>(`${this.appsettings.getApiURL()}/api/graphql`, {
        query: query,
        variables: variables
      })
      .pipe(map((d) => d.data))
      .pipe(map((d) => f ? f(d) : d));
  }

}
